image: gradle:8-jdk21

include:
  - project: rug-digitallab/resources/gitlab-ci-templates
    ref: develop
    file:
      - gradle/coverage/coverage.yml
      - gradle/test/unit-tests-with-docker.yml
      - gradle/static-analysis/static-analysis.yml
      - gradle/release/release.yml
      - gradle/build/compile-kotlin.yml
  - project: rug-digitallab/resources/gitlab-ci-templates
    ref: develop
    file: containers/publish.yml
    inputs:
      image_name: "repositories"
      dockerfile: "repositories/src/main/docker/Dockerfile.jvm"
  - project: rug-digitallab/resources/gitlab-ci-templates
    ref: develop
    file: containers/publish.yml
    inputs:
      image_name: "worker-gitlab"
      dockerfile: "worker-gitlab/src/main/docker/Dockerfile.jvm"

stages:
  - build
  - test
  - coverage
  - container-build
  - pre-release
  - release
  - post-release
  - publish
  - static-analysis

variables:
  # Set the gradle user home to a subdirectory of the build directory,
  # enable the build cache, and print verbose output.
  GRADLE_CLI: "./gradlew --gradle-user-home gradle-home/ --build-cache -i"

cache:
  key:
    files:
      # When the gradle wrapper changes, invalidate cache
      - gradle/wrapper/gradle-wrapper.properties
  paths:
    - gradle-home/wrapper/
    - gradle-home/caches/
    - gradle-home/notifications/

unit-test:
  # Requires Node.js to be present during the test stage
  image: registry.gitlab.com/rug-digitallab/resources/container-images/gradle-nodejs:latest

repositories-container-build-and-push:
  needs:
    - unit-test
  stage: container-build

worker-gitlab-container-build-and-push:
  needs:
    - unit-test
  stage: container-build
